Index: /trunk/Cosmo/RadioBeam/mdish.cc
===================================================================
--- /trunk/Cosmo/RadioBeam/mdish.cc	(revision 3973)
+++ /trunk/Cosmo/RadioBeam/mdish.cc	(revision 3974)
@@ -24,7 +24,7 @@
   switch (typ_) 
     {
-    case 1:   // Reponse gaussienne parabole diametre D exp[ -2 (lambda  k_g / D )^2 ]
+    case 1:   // Reponse gaussienne parabole diametre D exp[ -(1/8) (lambda  k_g / D )^2 ]
       wk = sqrt(kx*kx+ky*ky)/dx_;
-      wk = 2*wk*wk;
+      wk = wk*wk/8.;
       return exp(-wk);
       break;
Index: /trunk/Cosmo/RadioBeam/subtractradsrc.cmd
===================================================================
--- /trunk/Cosmo/RadioBeam/subtractradsrc.cmd	(revision 3973)
+++ /trunk/Cosmo/RadioBeam/subtractradsrc.cmd	(revision 3974)
@@ -74,5 +74,5 @@
 ## Step 3/ Apply lobe (50 meter diameter array) effect on foreground cube and LSS cube
 csh> set ddish=55.
-csh> set ddishcor=50.
+csh> set ddishcor=55.
 csh> ./Objs/applobe $ddish fgndcube.ppf fgndcube_lobe.ppf
 csh> ./Objs/applobe -fib $ddish fgndcube.ppf fgndcube_flobe.ppf
@@ -114,5 +114,5 @@
 # 4.c/ Extract LSS P(k) from Foreground+LSS+noise , after cleaning/subtraction without beam 
 csh> set beamdesc=repf11x11.ppf
-csh> set ddishcor=50.
+csh> set ddishcor=55.
 csh> set noiselev=1.
 csh> ./Objs/calcpk2 lsscube.ppf 0.13 fgndcube.ppf 1000 subpk.ppf $noiselev $beamdesc 0. 0. P2
@@ -120,5 +120,5 @@
 csh> ./Objs/calcpk2 lsscube_lobe.ppf 0.13 fgndcube_lobe.ppf 1000 subpklobe.ppf $noiselev $beamdesc 0. 0. P2 
 # 4.e / Extract LSS P(k) from Foreground+LSS+noise and beam effect - correcting to a beam of Diam= $ddishcor
-csh> ./Objs/calcpk2 lsscube_lobe.ppf 0.13 fgndcube_lobe.ppf 1000 subpkcorlobe.ppf $noiselev $beamdesc $ddishcor 0. P2 
+csh> ./Objs/calcpk2 lsscube_lobe.ppf 0.13 fgndcube_lobe.ppf 1000 subpkcorlobe.ppf $noiselev $beamdesc $ddishcor 0. P2 reclsscorlobe.ppf 
 #  Or using a linear fit for foreground subtraction (old version)
 csh> ./Objs/calcpk2 lsscube_lobe.ppf 0.13 fgndcube_lobe.ppf 1000 subpkcorlobep1.ppf $noiselev $beamdesc $ddishcor 0. P2 
@@ -141,9 +141,10 @@
 
 openppf subpkcorlobe.ppf 
-openppf subpknolss.ppf
-
+
+openppf residcorlobe.ppf 
+openppf residnocor.ppf
 # openppf subpknolssnocor.ppf
 
-disp lsspk 'logx logy nsta xylimits=0.005,2.,4e-11,8e-6 gold'
+disp lsspk 'logx logy nsta xylimits=0.01,2.,4e-11,8e-6 gold'
 disp lsspklobe 'same nsta orange'
 disp lsspklobewn 'same nsta siennared'
@@ -151,8 +152,13 @@
 
 
-disp fgndpk 'logx logy nsta xylimits=0.005,2.,1e-10,1. navyblue'
+disp fgndpk 'logx logy nsta xylimits=0.01,2.,1e-10,1. navyblue'
 disp fgndpklobe 'same nsta blue'
 disp fgndpkcorlobe 'same nsta skyblue'
 disp lsspk 'same nsta gold'
+disp lsspkflobe 'same nsta yellow'
+disp subpkcorlobe 'same nsta red' 
+disp residcorlobe 'same nsta green'
+disp residnocor 'same nsta forestgreen'
+
 disp lsspklobewn 'same nsta siennared' 
 # settitle 'Pk[LSS] , Pk[Foreground] and lobe effect (Dish D=50 m)' ' ' 'font=helvetica,bold,18'
@@ -171,5 +177,7 @@
 #  Calcul du volume total en Mpc^3
 set VOL (1.9*1.9*2.8*800*600*256)
-plot2d lsspk x val*$VOL 1 'logx logy nsta xylimits=0.01,2.,10.,1e4 cpts marker=box,5 gold'
+# set VOL (1.9*1.9*2.8*1800*600*256)
+plot2d 
+# plot2d lsspk x val*$VOL 1 'logx logy nsta xylimits=0.01,2.,10.,1e4 cpts marker=box,5 gold'
 plot2d lsspklobewn x val*$VOL 1 'same nsta cpts marker=box,5 siennared' 
 plot2d subpkcorlobe x val*$VOL 1 'same nsta cpts marker=box,5 red' 
@@ -184,5 +192,13 @@
 textdrawer lines cols 'font=helvetica,bold,16 frame'
 
-
+plot2d fgndpk x val*$VOL 1 'logx logy  xylimits=0.01,1.,1.,1e10 nsta cpts marker=box,5 black'
+plot2d fgndpkflobe x val*$VOL 1 ' nsta cpts marker=circle,5 navyblue same'
+plot2d fgndpklobe x val*$VOL 1 ' nsta cpts marker=circle,5 blue same'
+
+plot2d lsspk x val*$VOL 1 ' nsta cpts marker=box,5 red same'
+plot2d lsspkflobe x val*$VOL 1 ' nsta cpts marker=circle,5 orange same'
+plot2d lsspklobe x val*$VOL 1 ' nsta cpts marker=circle,5 yellow same'
+
+h/oper 
 plot2d lsspk x val*$VOL 1 'logx logy nsta xylimits=0.01,2.,10.,1e4 cpts marker=box,5 gold'
 plot2d lsspklobewn x val*$VOL 1 'same nsta cpts marker=box,5 red' 