Index: /trunk/Cosmo/RadioBeam/cubedef.h
===================================================================
--- /trunk/Cosmo/RadioBeam/cubedef.h	(revision 3974)
+++ /trunk/Cosmo/RadioBeam/cubedef.h	(revision 3975)
@@ -45,18 +45,20 @@
 static int HPk_NBin = 384;
 
-
+// --- Carte HASLAM 
+static double FreqHASLAM = 408.;   // frequence carte HASLAM en MHz 
+ 
 //---  Parametres des lois de puissance en frequence 
 static double AmpPL1 = 1.;   // amp max PowerLaw 1 (synchrotron  
 static double PLidx1 = -2.8;  // index de la loi de puissance synchrotron 
-static double sigPLidx1 = 0.1;  // Sigma de la variation (gaussienne) de index1 
+static double sigPLidx1 = 0.15;  // Sigma de la variation (gaussienne) de index1 
 // Amplitude max de la 2eme composante en loi de puissance (tirage plat 0 ... AmpPL2)
-static double AmpPL2 = 0.1;   // amp max PowerLaw 2 
+static double AmpPL2 = 0.;   // amp max PowerLaw 2 0. ---> pas de  
 static double PLidx2 = -3.2; 
 static double sigPLidx2 = 0.15;
 
-// Generation de la loi de puissance des sources : 
-static double PLidxSrc = -2.0;  // index de la loi de puissance des sources  
-static double sigPLidxSrc = 0.15;  // Sigma de la variation (gaussienne) de l'index  
-
+// Generation de la loi de puissance des sources : generation plate ds [PLidxSrcMin,PLidxSrcMax 
+static double PLidxSrcMin = -2.;  // index mini de la loi de puissance des sources
+static double PLidxSrcMax = -1.5;  // index maxi de la loi de puissance des sources  
+  
 /*
 static sa_size_t NTheta=256;
Index: /trunk/Cosmo/RadioBeam/plpkn.pic
===================================================================
--- /trunk/Cosmo/RadioBeam/plpkn.pic	(revision 3974)
+++ /trunk/Cosmo/RadioBeam/plpkn.pic	(revision 3975)
@@ -142,14 +142,14 @@
   plot2d pknF4cylp k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts green nsta notit' 
 
-  plot2d pknG8cyl k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts violetred nsta notit' 
-  plot2d pknG8cylp k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts violet nsta notit' 
+  plot2d pknG8cyl k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts orangered nsta notit' 
+  plot2d pknG8cylp k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts siennared nsta notit' 
 
   Dx = 5*0.9
   Dy = 5*0.9
   calcul 
-  plot2d pknE400d k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts turquoise nsta notit'
+  plot2d pknE400d k/$Da pnoise*$PNOISE fracmodok>0.2 'same line=solid,2 cpts darkviolet nsta notit'
 
   set lines (  '(e) 20x20:400xD=5m' '(f) 4Cyl-12mx85m, 400 rec/pol' '(fp) 4Cylp-12mx85m, 400 rec/pol'  '(g) 8Cyl-12mx105m, 960 rec/pol' '(gp) 8Cylp-12mx105m, 960 rec/pol' )
-  set cols ( turquoise forestgreen green violetred violet  )
+  set cols ( darkviolet forestgreen green orangered siennared  )
   textdrawer lines cols 'frame font=helvetica,bold,16  inset=0.1,0.3,0.15,0.35' 
   settitle ' PNoise(k) : Dishes/Cylinders, 400/400/960 recv/pol @z=1' ' ' 'font=helvetica,bold,16' 
Index: /trunk/Cosmo/RadioBeam/srcat2cube.cc
===================================================================
--- /trunk/Cosmo/RadioBeam/srcat2cube.cc	(revision 3974)
+++ /trunk/Cosmo/RadioBeam/srcat2cube.cc	(revision 3975)
@@ -210,5 +210,5 @@
   for (sa_size_t j=0; j<ocube.SizeY(); j++)  {
     for (sa_size_t i=0; i<ocube.SizeX(); i++)  {
-      double freqexpo = rg.Gaussian(sigPLidxSrc,PLidxSrc);
+      double freqexpo = PLidxSrcMin+rg.Flat01()*(PLidxSrcMax-PLidxSrcMin);
       for (sa_size_t k=0; k<ocube.SizeZ(); k++)  {
 	double rapfreq = pow((freq0+k*dfreq)/infreq, freqexpo);
Index: /trunk/Cosmo/RadioBeam/subtractradsrc.cmd
===================================================================
--- /trunk/Cosmo/RadioBeam/subtractradsrc.cmd	(revision 3974)
+++ /trunk/Cosmo/RadioBeam/subtractradsrc.cmd	(revision 3975)
@@ -136,4 +136,6 @@
 openppf lsspk.ppf 
 openppf lsspklobe.ppf 
+openppf lsspkcorlobe.ppf 
+
 openppf lsspkflobe.ppf 
 openppf lsspklobewn.ppf 
@@ -200,5 +202,8 @@
 plot2d lsspklobe x val*$VOL 1 ' nsta cpts marker=circle,5 yellow same'
 
-h/oper 
+c++exec \
+  Histo lsspkratioA = subpkcorlobe/lsspk; KeepObj(lsspkratioA); \
+  Histo lsspkratioB = subpkcorlobe/lsspkflobe; KeepObj(lsspkratioB); 
+
 plot2d lsspk x val*$VOL 1 'logx logy nsta xylimits=0.01,2.,10.,1e4 cpts marker=box,5 gold'
 plot2d lsspklobewn x val*$VOL 1 'same nsta cpts marker=box,5 red' 
Index: /trunk/Cosmo/RadioBeam/syncube.cc
===================================================================
--- /trunk/Cosmo/RadioBeam/syncube.cc	(revision 3974)
+++ /trunk/Cosmo/RadioBeam/syncube.cc	(revision 3975)
@@ -131,5 +131,5 @@
     TArray<r_4> ocube(NPhi,NTheta,NFreq);
 
-    double infreq = 400.; // Frequence carte input en MHz
+    double infreq = FreqHASLAM; // Frequence carte input en MHz
     double freq0 = Freq0MHz;  // Freq0 du cube de sortie 
     double dfreq = FreqSizeMHz/(double)NFreq;  
@@ -143,4 +143,5 @@
 	  ocube(i,j,k) = AmpPL1*omap(i,j)*rapfreq;
 	}
+	if (AmpPL2<1.e-6)  continue;
 	// On ajoute une autre composante avec un indice spectral different
 	freqexpo = rg.Gaussian(sigPLidx2,PLidx2); 