Index: /trunk/Cosmo/RadioBeam/sensfgnd21cm.tex
===================================================================
--- /trunk/Cosmo/RadioBeam/sensfgnd21cm.tex	(revision 3976)
+++ /trunk/Cosmo/RadioBeam/sensfgnd21cm.tex	(revision 3977)
@@ -100,5 +100,5 @@
    }
 
-   \date{Received December 15, 2010; accepted xxxx, 2011}
+   \date{Received June 15, 2011; accepted xxxx, 2011}
 
 % \abstract{}{}{}{}{} 
@@ -111,8 +111,8 @@
 cm emission. Such a 3D matter distribution map can be used to test the Cosmological model and to constrain the Dark Energy 
 properties or its equation of state. A novel approach, called intensity mapping can be used to map the \HI distribution, 
-using radio interferometers with large instanteneous field of view and waveband}
+using radio interferometers with large instanteneous field of view and waveband.}
  % aims heading (mandatory)
-  { In this paper, we study the sensitivity of different radio interferometer configuration for the observation of large scale structures 
-   and BAO oscillations in 21 cm and we discuss the problem of foreground removal. }
+  { In this paper, we study the sensitivity of different radio interferometer configurations, or multi-beam 
+instruments for the observation of large scale structures and BAO oscillations in 21 cm and we discuss the problem of foreground removal. }
   % methods heading (mandatory)
  { For each configuration, we determine instrument response by computing the (u,v) plane (Fourier angular frequency plane) 
@@ -124,5 +124,5 @@
    LSS power spectrum, after separation of 21cm-LSS signal from the foregrounds. }
   % conclusions heading (optional), leave it empty if necessary 
-   { We show that an interferometer with few hundred elements and a surface coverage of 
+   { We show that a radio instrument with few hundred simultaneous beamns and a surface coverage of 
   $\lesssim 10000 \mathrm{m^2}$ will be able to  detect BAO signal at redshift z $\sim 1$ }
 
@@ -422,8 +422,8 @@
 We have set the electromagnetic (EM) phase origin at the center of the coordinate frame and 
 the EM wave vector is related to the wavelength $\lambda$ through the usual 
-$ | \vec{k}_{EM} |  =  2 \pi / \lambda $. The receiver beam or antenna lobe $L(\vec{\Theta})$ 
+$ | \vec{k}_{EM} |  =  2 \pi / \lambda $. The receiver beam or antenna lobe $L(\vec{\Theta},\lambda)$ 
 corresponds to the receiver intensity response:
 \begin{equation}
-L(\vec{\Theta}) = B(\vec{\Theta},\lambda)  \,  B^*(\vec{\Theta},\lambda) 
+L(\vec{\Theta}), \lambda = B(\vec{\Theta},\lambda)  \,  B^*(\vec{\Theta},\lambda) 
 \end{equation} 
 The visibility signal between two receivers corresponds to the time averaged correlation between 
@@ -441,5 +441,5 @@
 the common receivers axis, the visibilty would be written as the 2D Fourier transform
 of the product of the sky intensity and the receiver beam, for the angular frequency 
-$2 \pi( \frac{\Delta x}{\lambda} ,  \frac{\Delta x}{\lambda} )$:
+\mbox{$(u,v)_{12} = 2 \pi( \frac{\Delta x}{\lambda} ,  \frac{\Delta x}{\lambda} )$}:
 \begin{equation}
 \vis(\lambda) \simeq  \iint d\alpha d\beta \, \, I(\alpha, \beta) \,  L(\alpha, \beta) 
@@ -478,4 +478,17 @@
 Several beam can be formed using different combination of the correlation from different 
 antenna pairs.  
+
+An instrument can thus be characterized by its $(u,v)$ plane coverage or response 
+${\cal R}(u,v,\lambda)$. For a single dish with a single receiver in the focal plane, 
+the instrument response is simply the Fourier transform of the beam. 
+For a single dish with multiple receivers, either as a Focal Plane Array (FPA) or 
+a multi horn system, each beam (b) will have its own response 
+${\cal R}_b(u,v,\lambda)$. 
+For an interferometer, we can compute a raw instrument response 
+${\cal R}_{raw}(u,v,\lambda)$ which corresponds to $(u,v)$ plane coverage by all 
+receiver pairs  with uniform weighting. 
+Obviously, different weighting schemes can be used, changing 
+the effective beam shape and thus the response ${\cal R}_{w}(u,v,\lambda)$
+and the noise behaviour.
 
 \begin{figure}
@@ -587,11 +600,11 @@
 
 \begin{figure}
-\vspace*{-10mm}
+\vspace*{-25mm}
 \centering
 \mbox{
 \hspace*{-10mm}
-\includegraphics[width=0.6\textwidth]{Figs/pnkmaxfz.pdf}
+\includegraphics[width=0.65\textwidth]{Figs/pnkmaxfz.pdf}
 }
-\vspace*{-35mm}
+\vspace*{-40mm}
 \caption{Minimal noise level for a 100 beam instrument as a function of redshift (top). 
  Maximum $k$ value for  a 100 meter diameter primary antenna (bottom) }
@@ -602,6 +615,6 @@
 \subsection{Instrument configurations and noise power spectrum}
 
-We have numerically computed the instrument response in the (u,v) plane for several 
-instrument configurations, at redshift $z=1$.
+We have numerically computed the instrument response ${\cal R}(u,v,\lambda)$ 
+with uniform weights in the $(u,v)$ plane for several instrument configurations:
 \begin{itemize}
 \item[{\bf a} :] A packed array of $n=121 \, D_{dish}=5 \mathrm{m}$ dishes, arranged in 
@@ -678,9 +691,10 @@
 \bigwedge_{[\pm 2 \pi D^{ill}_y / \lambda ]} (v ) 
 \end{equation}
-Figure \ref{figuvcovabcd} for the four configurations with $\sim 100$ receivers per 
+Figure \ref{figuvcovabcd} shows the instrument response ${\cal R}(u,v,\lambda)$ 
+for the four configurations (a,b,c,d) with $\sim 100$ receivers per 
 polarisation. The resulting projected noise spectral power density is shown in figure 
 \ref{figpnoisea2g}. The increase of $P_{noise}(k)$ at low $k^{comov} \lesssim 0.02$ 
 is due to the fact that we have ignored all auto-correlation measurements.  
-It can be seen that an instrument with $100$ beams and $\Tsys = 50 \mathrm{K}$ 
+It can be seen that an instrument with $100-200$ beams and $\Tsys = 50 \mathrm{K}$ 
 should have enough sensitivity to map LSS in 21 cm at redshift z=1.
 
@@ -716,5 +730,5 @@
 Reaching the required sensitivities is not the only difficulty of observing the large 
 scale structures in 21 cm. Indeed, the synchrotron emission of the 
-Milky Way and the extra galactic radio sources is a thousand time brighter than the 
+Milky Way and the extra galactic radio sources are a thousand time brighter than the 
 emission of the neutral hydrogen distributed in the universe. Extracting the LSS signal
 using Intensity Mapping, without identifying the \HI point sources is the main challenge 
@@ -723,5 +737,5 @@
 emissions can be used to separate the faint LSS signal from the Galactic and radio source 
 emissions. However, any real radio instrument has a beam shape which changes with 
-frequency which significantly increases the difficulty and complexity of this component separation 
+frequency: this instrumental effect significantly increases the difficulty and complexity of this component separation 
 technique. The effect of frequency dependent beam shape is often referred to as {\em 
 mode mixing} \citep{morales.09}.
@@ -730,11 +744,11 @@
 the simple models we have used for computing the sky radio emissions in the GHz frequency 
 range. We present also a simple component separation method to extract the LSS signal and 
-its performance. We show in particular the effect of the instrument response and possible 
-way of getting around this difficulty. The results presented in this section concern the 
+its performance. We show in particular the effect of the instrument response on the recovered 
+power spectrum, and possible way of getting around this difficulty. The results presented in this section concern the 
 total sky emission and the LSS 21 cm signal extraction in the $z \sim 0.6$ redshift range,
 corresponding to the central frequency $\nu \sim 884$ MHz.  
  
 \subsection{ Synchrotron and radio sources }
-We have modeled the radio in the form of three dimensional maps (data cubes) of sky temperature 
+We have modeled the radio sky in the form of three dimensional maps (data cubes) of sky temperature 
 brightness $T(\alpha, \delta, \nu)$ as a function of two equatorial angular coordinates $(\alpha, \delta)$ 
 and the frequency $\nu$. Unless otherwise specified, the results presented here are based on simulations of 
@@ -760,5 +774,5 @@
 Frequency & 500 kHz ($d z \sim 10^{-3}$) & 256 \\
 \hline
-\end{tabular} \\
+\end{tabular} \\[1mm]
 Cube size : $ 90 \, \mathrm{deg.} \times 30 \, \mathrm{deg.} \times 128 \, \mathrm{MHz}$   \\
 $ 1800 \times 600 \times 256 \simeq 123 \, 10^6$ cells 
@@ -775,11 +789,11 @@
 
 We have thus also created a simple sky model using the Haslam Galactic synchrotron map
-at 408 Mhz \citep{haslam.08} and the NRAO VLA Sky Survey (NVSS) 1.4 GHz radio source 
+at 408 Mhz \citep{haslam.82} and the NRAO VLA Sky Survey (NVSS) 1.4 GHz radio source 
 catalog \cite{nvss.98}. The sky temperature cube in this model (Model-II/Haslam+NVSS) 
 has been computed through the following steps:
 
 \begin{enumerate}
-\item The Galactic synchrotron emission is modeled as a sum of two power law.
-We assign a power law index $\beta = -2.8  \pm 0.15$ to each sky direction.
+\item The Galactic synchrotron emission is modeled power law with spatially 
+varying spectral index. We assign a power law index $\beta = -2.8  \pm 0.15$ to each sky direction.
 $\beta$ has a gaussian distribution centered at -2.8 and with standard 
 deviation $\sigma_\beta = 0.15$.
@@ -790,7 +804,7 @@
 \item A two dimensional $T_{nvss}(\alpha,\delta)$sky brightness temperature at 1.4 GHz is computed 
 by projecting the radio sources in the NVSS catalog to a grid with the same angular resolution as 
-the sky cubes is computed. The source brightness in Jansky is converted to temperature taking the 
-pixel angular size into account ($ \sim 21 \mathrm{mK / mJansky}$ at 1.4 Ghz and $3' \times 3'$ pixels).  
-A sepctral index $\beta_{src} \in [-1.5,-2]$ is also assigned to each sky direction for the radio source 
+the sky cubes. The source brightness in Jansky is converted to temperature taking the 
+pixel angular size into account ($ \sim 21 \mathrm{mK / mJansky}$ at 1.4 GHz and $3' \times 3'$ pixels).  
+A spectral index $\beta_{src} \in [-1.5,-2]$ is also assigned to each sky direction for the radio source 
 map; we have taken $\beta_{src}$ as a flat random number in the range $[-1.5,-2]$, and the 
 contribution of the radiosources to the sky temperature is computed as follow:
@@ -806,9 +820,9 @@
 \footnote{SimLSS : {\tt http://www.sophya.org/SimLSS} }.  
 {\color{red}: CMV, please add few line description of SimLSS}. 
-We have generated the mass fluctuations $\delta \rho/rho$ at $z=0.6$, in cells of size 
+We have generated the mass fluctuations $\delta \rho/\rho$ at $z=0.6$, in cells of size 
 $1.9 \times 1.9 \times 2.8 \, \mathrm{Mpc^3}$, which correspond approximately to the 
 sky cube angular and frequency resolution defined above.  The mass fluctuations has been 
-converted into temperature through a factor $0.13 mK$, corresponding to a hydrogen 
-fraction $0.008x(1+0.6)$.  The total sky brightness temperature is then computed as the sum 
+converted into temperature through a factor $0.13 \mathrm{mK}$, corresponding to a hydrogen 
+fraction $0.008 \times (1+0.6)$.  The total sky brightness temperature is then computed as the sum 
 of foregrounds and the LSS 21 cm emission:
 $$  T_{sky} = T_{sync}+T_{radsrc}+T_{lss}   \hspace{5mm} OR \hspace{5mm} 
@@ -840,9 +854,9 @@
 \end{table}
 
-we have computed the power spectrum on the 21cm-LSS sky temperature cube, as well 
-as on the radio foreground temperature cubes computed using our two foreground 
+we have computed the power spectrum for the 21cm-LSS sky temperature cube, as well 
+as for the radio foreground temperature cubes computed using our two foreground 
 models. We have also computed the power spectrum on sky brightness temperature
 cubes, as measured by a perfect instrument having a 25 arcmin gaussian beam.
-The resulting computed power spectrum are shown on figure \ref{pkgsmlss}. 
+The resulting computed power spectra are shown on figure \ref{pkgsmlss}. 
 The GSM model has more large scale power compared to our simple model, while
 it lacks power at higher spatial frequencies. The mode mixing due to 
@@ -853,10 +867,19 @@
 compared to the mK LSS signal.  
 
+It should also be noted that in section 3, we presented the different instrument 
+configuration noise level after {\em correcting or deconvolving} the instrument response. The LSS 
+power spectrum is recovered unaffected in this case, while the noise power spectrum 
+increases at high k values (small scales). In practice, clean deconvolution is difficult to 
+implement for real data and the power spectra presented in this section are NOT corrected 
+for the instrumental response. 
+
 \begin{figure}
 \centering
+\vspace*{-10mm}
 \mbox{
-\hspace*{-10mm}
-\includegraphics[width=0.5\textwidth]{Figs/comptempgsm.pdf}
+\hspace*{-20mm}
+\includegraphics[width=0.6\textwidth]{Figs/comptempgsm.pdf}
 }
+\vspace*{-10mm}
 \caption{Comparison of GSM (black) Model-II (red) sky cube temperature distribution.
 The Model-II (Haslam+NVSS),
@@ -869,5 +892,5 @@
 \mbox{
 \hspace*{-10mm}
-\includegraphics[width=\textwidth]{Figs/compmapgsm.pdf}
+\includegraphics[width=0.9\textwidth]{Figs/compmapgsm.pdf}
 }
 \caption{Comparison of GSM map (top) and Model-II sky map at 884 MHz (bottom). 
@@ -883,5 +906,5 @@
 \includegraphics[width=0.7\textwidth]{Figs/pk_gsm_lss.pdf}
 }
-\vspace*{-30mm}
+\vspace*{-40mm}
 \caption{Comparison of the 21cm LSS power spectrum (red, orange) with the radio foreground power spectrum.
 The radio sky power spectrum is shown for the GSM (Model-I) sky model (dark blue), as well as for our simple
@@ -893,17 +916,102 @@
 
 
-\subsection{ LSS signal extraction }
-% {\color{red} \large \it  CMV + Reza  +  J.M. Martin  } \\[1mm] 
-Description of the component separation method and the results 
-\begin{itemize}
-\item Component separation method, based on instrument response correction and frequency 
-smoothness / power law 
-\item Foreground power spectrum 
-\item Performance of component separation : comparison of frequency slices of recovered LSS 
-and foreground maps, source catalogs 
-\item Performance in statistical sense (power spectrum) : comparison of recovered P(k)-LSS 
-and true P(k), residual noise/systematic effect power spectrum 
-\end{itemize}
-
+\subsection{ Instrument response and LSS signal extraction }
+
+The observed data cube is obtained from the sky brightness temperature 3D map 
+$T_{sky}(\alpha, \delta, \nu)$ by applying the frequency dependent instrument response
+${\cal R}(u,v,\lambda)$. 
+As a simplification, we have considered that the instrument response is independent 
+of the sky direction.
+For each frequency $\nu_k$ or wavelength $\lambda_k=c/\nu_k$ : 
+\begin{enumerate}
+\item Apply a 2D Fourier transform to compute sky angular Fourier amplitudes
+$$ T_{sky}(\alpha, \delta, \lambda_k) \rightarrow \mathrm{2D-FFT} \rightarrow {\cal T}_{sky}(u, v, \lambda_k)$$ 
+\item Apply instrument response in the angular wave mode plane 
+$$  {\cal T}_{sky}(u, v, \lambda_k)  \longrightarrow {\cal T}_{sky}(u, v, \lambda_k) \times {\cal R}(u,v,\lambda) $$
+\item Apply inverse 2D Fourier transform to compute the measured sky brightness temperature map, 
+without instrumental (electronic/$\Tsys$) white noise:
+$$ {\cal T}_{sky}(u, v, \lambda_k) \times {\cal R}(u,v,\lambda)   
+\rightarrow \mathrm{Inv-2D-FFT} \rightarrow T_{mes1}(\alpha, \delta, \lambda_k) $$ 
+\item Add white noise (gaussian fluctuations) to obtain the measured sky brightness temperature 
+$T_{mes}(\alpha, \delta, \nu_k)$. We have also considered that the system temperature and thus the 
+additive white noise level was independent of the frequency or wavelength.   
+\end{enumerate} 
+The LSS signal extraction depends indeed on the white noise level. 
+The results shown here correspond to the (a) instrument configuration, a packed array of 
+$11 \times 11 = 121$ 5 meter diameter dishes, with a white noise level corresponding 
+to $\sigma_{noise} = 0.25 \mathrm{mK}$ per $3 \times 3 \mathrm{arcmin^2} \times 500 kHz$ 
+cell.
+
+Our simple component separation procedure is described below:
+\begin{enumerate}
+\item The measured sky brightness temperature is first corrected for the frequency dependent 
+beam effects through a convolution by a virtual, frequency independent beam. We assume 
+that we have a perfect knowledge of the intrinsic instrument response. 
+$$  T_{mes}(\alpha, \delta, \nu) \longrightarrow T_{mes}^{bcor}(\alpha,\delta,\nu) $$ 
+The virtual target instrument has a beam width larger to the worst real instrument beam,
+i.e at the lowest observed frequency.  
+ \item For each sky direction $(\alpha, \delta)$, a power law $T = T_0 \left( \frac{\nu}{\nu_0} \right)^b$
+ is fitted to the beam-corrected brightness temperature. $b$ is the power law index and  $10^a$ 
+is the brightness temperature at the reference frequency $\nu_0$:
+\begin{eqnarray*} 
+P1 & :  & \log10 ( T_{mes}^{bcor}(\nu) ) = a + b \log10 ( \nu / \nu_0 ) \\
+P2 & :  & \log10 ( T_{mes}^{bcor}(\nu) ) = a + b \log10 ( \nu / \nu_0 ) + c \log10 ( \nu/\nu_0 ) ^2 
+\end{eqnarray*}
+\item The difference between the beam-corrected sky temperature and the fitted power law
+$(T_0(\alpha, \delta), b(\alpha, \delta))$ is our extracted 21 cm LSS signal.
+\end{enumerate}
+
+Figure \ref{extlsspk} shows the performance of this procedure at a redshift $\sim 0.6$, 
+for the two radio sky models used here: GSM/Model-I and Haslam+NVSS/Model-II. The 
+21 cm LSS power spectrum, as seen by a perfect instrument with a gaussian frequency independent 
+beam is shown in orange (solid line), and the extracted power spectrum, after beam correction 
+and foreground separation with second order polynomial fit (P2) is shown in red (circle markers).
+We have also represented the obtained power spectrum without applying the beam correction (step 1 above),
+or with the first order polynomial fit (P1). 
+
+It can be seen that a precise knowledge of the instrument beam and the beam correction 
+is a key ingredient for recovering the 21 cm LSS power spectrum. It is also worthwhile to 
+note that while it is enough to correct the beam to the lowest resolution instrument beam 
+($\sim 30'$ or $D \sim 50$ meter @ 820 MHz) for the GSM model, a stronger beam correction 
+has to be applied (($\sim 36'$ or $D \sim 40$ meter @ 820 MHz) for the Model-II to reduce 
+significantly the ripples from bright radio sources. The effect of mode mixing is reduced for 
+an instrument with smooth (gaussian) beam, compared to the instrument response 
+${\cal R}(u,v,\lambda)$ used here.
+
+Figure \ref{extlssratio} shows the overall {\em transfer function} for 21 cm LSS power 
+spectrum measurement. We have shown (solid line, orange) the ratio of measured LSS power spectrum
+by a perfect instrument $P_{perf-obs}(k)$, with a gaussian beam of $\sim$ 36 arcmin, respectively $\sim$ 30 arcmin,
+in the absence of any foregrounds or instrument noise, to the original 21 cm power spectrum $P_{21cm}(k)$. 
+The ratio of the recovered LSS power spectrum $P_{ext}(k)$ to $P_{perf-obs}(k)$ is shown in red, and the 
+ratio of the recovered spectrum to  $P_{21cm}(k)$  is shown in black (thin line). 
+
+\begin{figure*}
+\centering
+\vspace*{-20mm}
+\mbox{
+\hspace*{-20mm}
+\includegraphics[width=1.1\textwidth]{Figs/extlsspk.pdf}
+}
+\vspace*{-30mm}
+\caption{Power spectrum of the 21cm LSS temperature fluctuations, separated from the 
+continuum radio emissions at $z \sim 0.6$. 
+Left: GSM/Model-I , right: Haslam+NVSS/Model-II.  }
+\label{extlsspk}
+\end{figure*}
+
+
+\begin{figure*}
+\centering
+\vspace*{-20mm}
+\mbox{
+\hspace*{-20mm}
+\includegraphics[width=1.1\textwidth]{Figs/extlssratio.pdf}
+}
+\vspace*{-30mm}
+\caption{Power spectrum of the 21cm LSS temperature fluctuations, separated from the 
+continuum radio emissions at $z \sim 0.6$. 
+Left: GSM/Model-I , right: Haslam+NVSS/Model-II.  }
+\label{extlssratio}
+\end{figure*}
 
 \section{ BAO scale determination and constrain on dark energy parameters}
@@ -911,7 +1019,12 @@
 We compute  reconstructed LSS-P(k) (after component separation) at different z's 
 and determine BAO scale as a function of redshifts.
-We can this a large number of time ( ~ 100 \ldots 1000 ) to have the reconstructed P(k) 
-with {\it realistic } errors. We can then determine the error on the reconstructed DE 
-parameters 
+Method: 
+\begin{itemize}
+\item Compute/guess the overall transfer function for several redshifts (0.5 , 1.0 1.5 2.0 2.5 ) \\
+\item Compute / guess the instrument noise level for the same redshit values
+\item Compute the observed P(k) and extract $k_{BAO}$ , and the corresponding error 
+\item Compute the DETF ellipse with different priors
+\end{itemize}
+
 
 \section{Conclusions}